﻿using System;
using System.Collections.Generic;
using HeuristicLab.Random;

namespace HeuristicLab.Problems.Instances.DataAnalysis {
  public class FeynmanInstanceProvider : ArtificialRegressionInstanceProvider {
    public override string Name {
      get { return "Feynman Benchmark Problems"; }
    }

    public override string Description {
      get { return ""; }
    }

    public override Uri WebLink {
      get { return new Uri("https://space.mit.edu/home/tegmark/aifeynman.html"); }
    }

    public override string ReferencePublication {
      get { return "asdf"; }
    }

    public int Seed { get; private set; }

    public FeynmanInstanceProvider() : this((int) DateTime.Now.Ticks) { }

    public FeynmanInstanceProvider(int seed) {
      Seed = seed;
    }

    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
      var descriptorList = new List<IDataDescriptor>();
      var rand           = new MersenneTwister((uint) Seed);
      descriptorList.Add(new Feynman1(rand.Next(), 10000, 10000));
      descriptorList.Add(new Feynman2(rand.Next()));
      descriptorList.Add(new Feynman3(rand.Next()));
      descriptorList.Add(new Feynman4(rand.Next()));
      descriptorList.Add(new Feynman5(rand.Next()));
      descriptorList.Add(new Feynman6(rand.Next()));
      descriptorList.Add(new Feynman7(rand.Next()));
      descriptorList.Add(new Feynman8(rand.Next()));
      descriptorList.Add(new Feynman9(rand.Next()));
      descriptorList.Add(new Feynman10(rand.Next()));
      descriptorList.Add(new Feynman11(rand.Next()));
      descriptorList.Add(new Feynman12(rand.Next()));
      descriptorList.Add(new Feynman13(rand.Next()));
      descriptorList.Add(new Feynman14(rand.Next()));
      descriptorList.Add(new Feynman15(rand.Next()));
      descriptorList.Add(new Feynman16(rand.Next()));
      descriptorList.Add(new Feynman17(rand.Next()));
      descriptorList.Add(new Feynman18(rand.Next()));
      descriptorList.Add(new Feynman19(rand.Next()));
      descriptorList.Add(new Feynman20(rand.Next()));
      descriptorList.Add(new Feynman21(rand.Next()));
      descriptorList.Add(new Feynman22(rand.Next()));
      descriptorList.Add(new Feynman23(rand.Next()));
      descriptorList.Add(new Feynman24(rand.Next()));
      descriptorList.Add(new Feynman25(rand.Next()));
      descriptorList.Add(new Feynman26(rand.Next()));
      descriptorList.Add(new Feynman27(rand.Next()));
      descriptorList.Add(new Feynman28(rand.Next()));
      descriptorList.Add(new Feynman29(rand.Next()));
      descriptorList.Add(new Feynman30(rand.Next()));
      descriptorList.Add(new Feynman31(rand.Next()));
      descriptorList.Add(new Feynman32(rand.Next()));
      descriptorList.Add(new Feynman33(rand.Next()));
      descriptorList.Add(new Feynman34(rand.Next()));
      descriptorList.Add(new Feynman35(rand.Next()));
      descriptorList.Add(new Feynman36(rand.Next()));
      descriptorList.Add(new Feynman37(rand.Next()));
      descriptorList.Add(new Feynman38(rand.Next()));
      descriptorList.Add(new Feynman39(rand.Next()));
      descriptorList.Add(new Feynman40(rand.Next()));
      descriptorList.Add(new Feynman41(rand.Next()));
      descriptorList.Add(new Feynman42(rand.Next()));
      descriptorList.Add(new Feynman43(rand.Next()));
      descriptorList.Add(new Feynman44(rand.Next()));
      descriptorList.Add(new Feynman45(rand.Next()));
      descriptorList.Add(new Feynman46(rand.Next()));
      descriptorList.Add(new Feynman47(rand.Next()));
      descriptorList.Add(new Feynman48(rand.Next()));
      descriptorList.Add(new Feynman49(rand.Next()));
      descriptorList.Add(new Feynman50(rand.Next()));
      descriptorList.Add(new Feynman51(rand.Next()));
      descriptorList.Add(new Feynman52(rand.Next()));
      descriptorList.Add(new Feynman53(rand.Next()));
      descriptorList.Add(new Feynman54(rand.Next()));
      descriptorList.Add(new Feynman55(rand.Next()));
      descriptorList.Add(new Feynman56(rand.Next()));
      descriptorList.Add(new Feynman57(rand.Next()));
      descriptorList.Add(new Feynman58(rand.Next()));
      descriptorList.Add(new Feynman59(rand.Next()));
      descriptorList.Add(new Feynman60(rand.Next()));
      descriptorList.Add(new Feynman61(rand.Next()));
      descriptorList.Add(new Feynman62(rand.Next()));
      descriptorList.Add(new Feynman63(rand.Next()));
      descriptorList.Add(new Feynman64(rand.Next()));
      descriptorList.Add(new Feynman65(rand.Next()));
      descriptorList.Add(new Feynman66(rand.Next()));
      descriptorList.Add(new Feynman67(rand.Next()));
      descriptorList.Add(new Feynman68(rand.Next()));
      descriptorList.Add(new Feynman69(rand.Next()));
      descriptorList.Add(new Feynman70(rand.Next()));
      descriptorList.Add(new Feynman71(rand.Next()));
      descriptorList.Add(new Feynman72(rand.Next()));
      descriptorList.Add(new Feynman73(rand.Next()));
      descriptorList.Add(new Feynman74(rand.Next()));
      descriptorList.Add(new Feynman75(rand.Next()));
      descriptorList.Add(new Feynman76(rand.Next()));
      descriptorList.Add(new Feynman77(rand.Next()));
      descriptorList.Add(new Feynman78(rand.Next()));
      descriptorList.Add(new Feynman79(rand.Next()));
      descriptorList.Add(new Feynman80(rand.Next()));
      descriptorList.Add(new Feynman81(rand.Next()));
      descriptorList.Add(new Feynman82(rand.Next()));
      descriptorList.Add(new Feynman83(rand.Next()));
      descriptorList.Add(new Feynman84(rand.Next()));
      descriptorList.Add(new Feynman85(rand.Next()));
      descriptorList.Add(new Feynman86(rand.Next()));
      descriptorList.Add(new Feynman87(rand.Next()));
      descriptorList.Add(new Feynman88(rand.Next()));
      descriptorList.Add(new Feynman89(rand.Next()));
      descriptorList.Add(new Feynman90(rand.Next()));
      descriptorList.Add(new Feynman91(rand.Next()));
      descriptorList.Add(new Feynman92(rand.Next()));
      descriptorList.Add(new Feynman93(rand.Next()));
      descriptorList.Add(new Feynman94(rand.Next()));
      descriptorList.Add(new Feynman95(rand.Next()));
      descriptorList.Add(new Feynman96(rand.Next()));
      descriptorList.Add(new Feynman97(rand.Next()));
      descriptorList.Add(new Feynman98(rand.Next()));
      descriptorList.Add(new Feynman99(rand.Next()));
      descriptorList.Add(new Feynman100(rand.Next()));

      return descriptorList;
    }
  }
}